<p align="center">
  <a href="https://snailjob.opensnail.com">
   <img alt="snail-job-Logo" src="doc/images/favicon.svg" width="200px">
  </a>
</p>

<p align="center">
     🔥🔥🔥 灵活，可靠和快速的分布式任务重试和分布式任务调度平台<br> <br/>
</p>

<p align="center">

> ✅️ 可重放，可管控、为提高分布式业务系统一致性的分布式任务重试平台 <br/>
> ✅️ 支持秒级、可中断、可编排的高性能分布式任务调度平台
>
</p>

# 简介

> SnailJob 是一个灵活、可靠且高效的分布式任务重试和任务调度平台。其核心采用分区模式实现，具备高度可伸缩性和容错性的分布式系统。拥有完善的权限管理、强大的告警监控功能和友好的界面交互。欢迎大家接入并使用。

# 开源地址
- [snail-job-admin](https://gitee.com/opensnail/snail-job-admin.git)(基于[soybean-admin](https://github.com/soybeanjs/soybean-admin)开源项目搭建)
- [snail-job-demo (Java客户端示例程序)](https://gitee.com/opensnail/snail-job-demo.git)
- [snail-job-python (Python客户端)](https://gitee.com/opensnail/snail-job-python.git)
- [snail-job-go (Go客户端)](https://gitee.com/opensnail/snail-job-go.git)
- [GitCode](https://gitcode.com/aizuda/snail-job)

# 预览地址
 https://snailjob.opensnail.com/docs/preview.html

## 特别用户
<a href="http://aizuda.com/?from=mp" >
  <img alt="snail-job-Logo" src="doc/images/aizuda.png" width="200px">
</a>
<a href="https://plus-doc.dromara.org/#/">
   <img alt="snail-job-Logo" src="doc/images/ryp.png" width="300px" height="71">
</a>

## 相关链接

- [字节跳动: 如何优雅地重试](https://juejin.cn/post/6914091859463634951)
- [这款分布式重试组件,治好了我的重试强迫症！](https://juejin.cn/post/7249607108043145274)
- [系统简介](https://snailjob.opensnail.com/docs/introduce/preface.html)

## 快速入门

- [服务部署](https://snailjob.opensnail.com/docs/guide/server/service_deployment.html)
- [QuickStart](https://snailjob.opensnail.com/docs/quickstart/quick_start.html)
- [xxljob迁移脚本](https://snailjob.opensnail.com/docs/guide/migration_tool.html)
- [OpenApi](https://snailjob.opensnail.com/docs/guide/openapi/openapi_overview.html)
- [Python客户端](https://snailjob.opensnail.com/docs/guide/client/python/python.html)
- [Go客户端](https://snailjob.opensnail.com/docs/guide/client/go/go.html)
- [Q/A](https://snailjob.opensnail.com/docs/QA.html)

## 系统截图

|                                                                                              |                                                                                              |
|----------------------------------------------------------------------------------------------|----------------------------------------------------------------------------------------------|
| ![系统截图](https://oscimg.oschina.net/oscnet/up-14e6a8b356b5af81ef5d29c5f11f409ec8e.png "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-c211e2ed8bb50b0b5a98a80c66a6b1c22eb.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-7f89940ef3ca77fcbc7c59a5ef1b7ee2f32.jpg "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-aaffbff80000f50760580f5c1b9eb129326.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-d22af7154271453ef9e474480b365de7fe8.jpg "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-b3960db7ec76046317a437129983d1b0fdb.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-c30f296734992f54c595489070242d5bedb.jpg "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-9ce9d14406c04e4a174fdb261f7a3dbb3c4.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-251bcb5854c6b194d572a2c9f749dcfa88c.jpg "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-fb4cc7f4d4c63d268cbc5d1b899ba0890cb.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-779062ece3bf7fbd7b815316043a9a81b17.jpg "屏幕截图") | ![系统截图](https://oscimg.oschina.net/oscnet/up-fd2cbb9b59710fb961bee83ade1acea0ee2.jpg "屏幕截图") |
| ![系统截图](https://oscimg.oschina.net/oscnet/up-e2a4fb0f130d1f3eceb5c05b0913074d12f.jpg "屏幕截图") | ![系统截图](https://foruda.gitee.com/images/1722959592856812900/e2d0d342_1419627.png "屏幕截图")     |


## 期望

欢迎提出更好的意见，帮助完善 snail-job

## 版权

Aizuda/SnailJob 采用[APACHE LICENSE 2.0](https://gitee.com/aizuda/snail-job/blob/master/LICENSE)
开源协议，您在使用过程中，需要注意以下几点:

1. 不得修改产品相关代码的源码头注释和出处;
2. 不得应用于危害国家安全、荣誉和利益的行为，不能以任何形式用于非法目的;
